﻿KKBK_VERSION = "0.2"
KKBK_NAME_VERSION = "KKBK "..KKBK_VERSION
kkbk_class = {}
MY_CLASS = ""
MY_CLASS_LOCALIZED = ""
addon_is_loaded = false
BUFFS = {}
ui_elements = {
    player_names = {},
    checkbox = {}
}
current_page = ""
pages = {}
is_raid_init = false

-- we suppose max 10 player from the same class
MAX_PLAYERS = 10
-- number of groups
MAX_GROUPS = 8

function supported_class(cl) 
    local class = { "PRIEST", "MAGE", "DRUID", "PALADIN" }
    for _, v in class do
        if cl == v then
            return true
        end
    end
    return false
end

function kkbk_onLoad()    
    playerClass, englishClass = UnitClass("player")
    MY_CLASS = englishClass
	MY_CLASS_LOCALIZED = playerClass
    if DEBUG then
        MY_CLASS = "PALADIN"
    end
    
    if not supported_class(MY_CLASS) then
        DEFAULT_CHAT_FRAME:AddMessage("|cff00ff00KikiBufKoi "..KKBK_VERSION.." " .. NOT .. " " .. LOADED .. " : " .. playerClass .. " " .. CLASS_NOT_SUPPORTED .. ".|r")
        return
    end
    
    this:RegisterEvent("ADDON_LOADED")
    
    --this:RegisterEvent("PLAYER_ENTERING_WORLD")
	SLASH_KKBK1 = "/kkbk"
	SlashCmdList["KKBK"] = kkbk_toggleFrame
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ff00KikiBufKoi "..KKBK_VERSION.." " .. LOADED .. ".|r")
    DEFAULT_CHAT_FRAME:AddMessage("|cff00ff00"..ENTER_SLASH .. ".|r")
    
    -- Allows kkbk to be closed with the Escape key (found in atlas code ^^)
	tinsert(UISpecialFrames, "kkbk_MainFrame");
end

function kkbk_InitUI()    
    local group_x = 10
    local group_y = -5
    local right_pos = 100
    local top_pos = -25
    local y_line = 4
    local x_line = 2
    
    -- place players
    for i=1, MAX_PLAYERS do
        ui_elements["player_names"][i] = CreateFrame("Frame", "player_label_"..i, kkbk_MainFramePanel2, "kkbk_label_player_template");
        local label = ui_elements["player_names"][i]
        label:SetPoint("TOPLEFT", "kkbk_MainFramePanel2", "TOPLEFT" , group_x, top_pos + (group_y * (i * y_line)));
        getglobal("player_label_"..i.."Text"):SetText("player"..i)
        label:Hide()
    end
    
    if MY_CLASS == "PALADIN" then
        -- place checkboxes
        for i=1, MAX_PLAYERS do
            ui_elements["checkbox"][i] = {}
            
            local ii = 1
            ui_elements["checkbox"][i][ii] = CreateFrame("CheckButton", "checkbox_"..i.."_"..ii, kkbk_MainFramePanel2, "kkbk_checkbutton_template");
            local label = ui_elements["checkbox"][i][ii]
            local my_x = right_pos + (group_x * (ii * x_line))
            local my_y = top_pos + (group_y * (i * y_line))
            label:SetPoint("TOPLEFT", "kkbk_MainFramePanel2", "TOPLEFT" , my_x, my_y)
            label:Hide()
            
            local vi = i
            local vii = ii
            ui_elements["checkbox"][i][ii] = label
            label:SetScript("OnClick", function() kkbk_checkboxClic(vi, vii) end)
        end
    else
        -- place group labels
        local group = CreateFrame("Frame", "group_names", kkbk_MainFramePanel2, "kkbk_label_group_template");
        group:SetPoint("TOPLEFT", "kkbk_MainFramePanel2", "TOPLEFT" , group_x, group_y);
        getglobal("group_namesText"):SetText(GROUP)
        group:Show()
        
        for i=1, MAX_GROUPS do
            local label = CreateFrame("Frame", "group_label_"..i, kkbk_MainFramePanel2, "kkbk_label_group_num_template");
            label:SetPoint("TOPLEFT", "kkbk_MainFramePanel2", "TOPLEFT" , right_pos + (group_x * (i * x_line)), group_y);
            getglobal("group_label_"..i.."Text"):SetText(""..i)
            label:Show()
        end
        
        -- place checkboxes
        for i=1, MAX_PLAYERS do
            ui_elements["checkbox"][i] = {}
            for ii=1, MAX_GROUPS do
                ui_elements["checkbox"][i][ii] = CreateFrame("CheckButton", "checkbox_"..i.."_"..ii, kkbk_MainFramePanel2, "kkbk_checkbutton_template");
                local label = ui_elements["checkbox"][i][ii]
                local my_x = right_pos + (group_x * (ii * x_line))
                local my_y = top_pos + (group_y * (i * y_line))
                label:SetPoint("TOPLEFT", "kkbk_MainFramePanel2", "TOPLEFT" , my_x, my_y)
                label:Hide()
                
                local vi = i
                local vii = ii
                ui_elements["checkbox"][i][ii] = label
                label:SetScript("OnClick", function() kkbk_checkboxClic(vi, vii) end)
            end
        end
    end
    
    for key, value in BUFFS[MY_CLASS] do
        local button = CreateFrame("Button", "buff_btn_"..key, kkbk_MainFramePanel3, "kkbk_buff_btn_template")
        button:SetPoint("CENTER", "kkbk_MainFramePanel3", "TOP" , 0, 0 - (key * y_line * 6))
        local string = getglobal("buff_btn_"..key.."Text");
        kkbk_debug(key .. " " .. " " .. value.longName .. " " .. value.shortName)
        
        local shortName = value.shortName
        local longName = value.longName

        button:SetScript("OnClick", function() kkbk_page(shortName, longName) end);
        button:Show()
        button:SetText(value.shortName)
        
        if key == 1 then
            kkbk_page(shortName, longName)
        end
    end
end

function kkbk_onEvent()
    if event == RAID_ROSTER_UPDATE then
        kkbk_debug("RAID_ROSTER_UPDATE")
    elseif event == "ADDON_LOADED" and strlower(arg1) == "kkbk" then
        if kkbk_options == nil then
	        kkbk_options = CloneTable(kkbk_defaultOptions)
        end
        kkbk_remapLanguage(kkbk_options["prefered_language"])
        addon_is_loaded = true
        kkbk_UpdatePosition()
        kkbk_minimapInit()
        kkbk_InitUI()
    end
end

function kkbk_page(shortName, longName)
    kkbk_debug("changing page : " .. shortName);
    current_page = shortName
    
    if MY_CLASS == "PALADIN" then
        if not pages[current_page] then
            pages[current_page] = {}
            for i=1, MAX_PLAYERS do
                pages[current_page][i] = {}
                pages[current_page][i][1] = nil
                ui_elements["checkbox"][i][1]:SetChecked(nil)
            end
        else
            for i=1, MAX_PLAYERS do
                ui_elements["checkbox"][i][1]:SetChecked(pages[current_page][i][1])
            end
        end
    else
        if not pages[current_page] then
            pages[current_page] = {}
            for i=1, MAX_PLAYERS do
                pages[current_page][i] = {}
                for ii=1, MAX_GROUPS do
                    pages[current_page][i][ii] = nil
                    ui_elements["checkbox"][i][ii]:SetChecked(nil)
                end
            end
        else
            for i=1, MAX_PLAYERS do
                for ii=1, MAX_GROUPS do
                    ui_elements["checkbox"][i][ii]:SetChecked(pages[current_page][i][ii])
                end
            end
        end
    end
    kkbk_buff_name:SetText(longName)
end

function kkbk_checkboxClic(i, ii)
    pages[current_page][i][ii] = true
    for o=1, MAX_PLAYERS do
        if o ~= i and ui_elements["checkbox"][o][ii]:IsVisible() then
            ui_elements["checkbox"][o][ii]:SetChecked(nil)
            pages[current_page][o][ii] = nil
        end
    end
end

function kkbk_toggleFrame()
	if (kkbk_MainFrame:IsVisible()) then
		kkbk_MainFrame:Hide()
	else
		kkbk_MainFrame:Show()
	end	
end

function kkbk_sendToChan()   
    --[[local buffs = {
        ["nom_player"] = { buff = "", groups = {1, 2, 3, 4}
    }]]
    local buffs = {}
    
    --local strg = ""
    for page, arr in pages do
        for player, groups in arr do
            local group_to_buff = {}
            
            for group, buff in groups do
                if buff ~= nil then
                    table.insert(group_to_buff, group)
                    table.sort(group_to_buff)
                end
            end
            
            for k, v in group_to_buff do
                kkbk_debug("check " .. k .. " " .. v)
            end
    
            if kkbk_tcount(group_to_buff) > 0 then
                name = kkbk_class[player]
                if not buffs[name] then
                    buffs[name] = {}
                end
                if not buffs[name][page] then
                    buffs[name][page] = {}
                end
                buffs[name][page] = group_to_buff 
            end
        end
    end
    
    if kkbk_tcount(buffs) > 0 then    
        local message = {}
        
        --[[ array looks like
        buffs = {
            ["player 1"] = {
                ["Stamina"] = { 1, 2, 3, 4 }
            }
        }
        ]]
        for player, arr in buffs do
            local strg = "[" .. player .. "] "
            
            for buff, groups in arr do
                if MY_CLASS == "PALADIN" then
                    strg = strg .. " => " .. buff
                else
                    strg = strg .. buff .. " => [" .. table.concat(groups, ", ") .. "] "
                end
            end
            
            if not kkbk_options["separate_line"] then
                if not message[1] then
                    message[1] = strg
                else
                    message[1] = message[1] .. " " .. strg
                end
            else
                table.insert(message, strg)
            end
        end
        
        for _, lines in message do
            if kkbk_options["channel"]["is_raid"] then
                SendChatMessage(lines, "RAID", nil)
            elseif kkbk_options["channel"]["is_group"] then
                SendChatMessage(lines, "PARTY", nil)
            elseif kkbk_options["channel"]["is_channel"] then
               id, name = GetChannelName(kkbk_options["channel"]["channel"])
                SendChatMessage(lines, "CHANNEL", nil, id)
            end
        end
    end
end

function kkbk_resetEvent()
    kkbk_reset()
    kkbk_initRaid()
    kkbk_page(current_page, kkbk_getLongName(current_page))
end

function kkbk_getLongName(short)
    for key, value in BUFFS[MY_CLASS] do
        if value.shortName == short then
            return value.longName
        end
    end
    return ""
end

function kkbk_reset()
    is_raid_init = false
    kkbk_class = {}
    for i=1, MAX_PLAYERS do
        ui_elements["player_names"][i]:Hide()
        for ii=1, MAX_GROUPS do
            ui_elements["checkbox"][i][ii]:Hide()
            ui_elements["checkbox"][i][ii]:SetChecked(nil)
            pages = {}
        end
    end
end

function kkbk_getRaidMembers()
    -- getting all players from selected class
    if DEBUG then
        kkbk_class = { "Pierre", "Paul", "Jacques", "Jean", "Marc", "Pascal"}
    else
	    local o=1
        for i=1, GetNumRaidMembers() do
            name = GetRaidRosterInfo(i)
            if name ~= nil then
                playerClass, englishClass = UnitClass("raid"..i);
                if englishClass ~= nil and playerClass ~= nil then
                    if englishClass == MY_CLASS then
                        kkbk_class[o] = name
                        kkbk_debug("add "..name.." to " ..playerClass)
			            o = o + 1
                    end
                end
            end
        end
    end
    table.sort(kkbk_class)
end

function kkbk_initRaid()    
    if is_raid_init then return end

    kkbk_debug("init raid");
    
    is_raid_init = true
    
    -- get raid members
    kkbk_getRaidMembers()
    
    -- ok, now we can draw the window
    local i = 1
    for k, v in kkbk_class do
        getglobal(ui_elements["player_names"][i]:GetName().."Text"):SetText(v)
        ui_elements["player_names"][i]:Show()
        if MY_CLASS == "PALADIN" then
            ui_elements["checkbox"][i][1]:Show()
        else
            for ii = 1, MAX_GROUPS do
                ui_elements["checkbox"][i][ii]:Show()
            end
        end
        i = i + 1
    end
end